/* *******************************************************************
   13.4@K
******************************************************************* */
#include<stdio.h>
#include<math.h>

/* ֐f(x,y,z)̒` */
float f(float x, float y, float z){
	float ff=z;
	return ff;
}

/* ֐g(x,y,z)̒` */
float g(float x, float y, float z){
	float gg=0.25*(1.0-pow(y,2))*z-y+sin(x);
	return gg;
}

/* CvO */
int main(void){
	int   n=100;
	float h=0.1;
	int   j;
	float s1,s2,s3,s4,r1,r2,r3,r4;
	float x[n+1];
	float y[n+1];
	float z[n+1];
	x[0]=0.0;
	y[0]=0.0;
	z[0]=0.0;
	
	/* IC[@̏ꍇ */
	for(j=0; j<=n-1; j++){
		x[j+1]=x[j]+h;
		y[j+1]=y[j]+h*f(x[j],y[j],z[j]);
        z[j+1]=z[j]+h*g(x[j],y[j],z[j]);
	}
	/* IC[@̌ʂ̉ʏo */
	printf("Eular:\n");
	printf("%6s %15s %15s %15s\n", "j", "x[j]", "y[j]", "z[j]");
	for(j=0; j<=n; j++){
		printf("%6d %15.6f %15.6f %15.6f \n", j, x[j], y[j], z[j]);
	}
	printf("\n");

	/* QENb^@̏ꍇ */
	for(j=0; j<=n-1; j++){
		s1=f(x[j],y[j],z[j]);
		r1=g(x[j],y[j],z[j]);
		s2=f(x[j]+h/2.0,y[j]+h*s1/2.0,z[j]+h*r1/2.0);
		r2=g(x[j]+h/2.0,y[j]+h*s1/2.0,z[j]+h*r1/2.0);
		s3=f(x[j]+h/2.0,y[j]+h*s2/2.0,z[j]+h*r2/2.0);
		r3=g(x[j]+h/2.0,y[j]+h*s2/2.0,z[j]+h*r2/2.0);
		s4=f(x[j]+h,y[j]+h*s3,z[j]+h*r3);
		r4=g(x[j]+h,y[j]+h*s3,z[j]+h*r3);
		x[j+1]=x[j]+h;
		y[j+1]=y[j]+h/6.0*(s1+2.0*s2+2.0*s3+s4);
		z[j+1]=z[j]+h/6.0*(r1+2.0*r2+2.0*r3+r4);
	}
	/* QENb^@̌ʂ̉ʏo */
	printf("Runge-Kutta:\n");
	printf("%6s %15s %15s %15s\n", "j", "x[j]", "y[j]", "z[j]");
	for(j=0; j<=n; j++){
		printf("%6d %15.6f %15.6f %15.6f \n", j, x[j], y[j], z[j]);
	}
	
	return 0;
}
