/* *******************************************************************
   7.3@Rr@
******************************************************************* */
#include<stdio.h>
#include<math.h>

/* ]us쐬֐iU̓]usUTɊi[ĕԂj */
float transposition(int n, float U[n+1][n+1], float UT[n+1][n+1]){
	int    i,j;
	
	for(j=1; j<=n; j++){
		for(i=1; i<=n; i++){
			UT[j][i]=U[i][j];
		}
	}
}

/* s̊|ZTu[`iA*BCɊi[ĕԂj */
float multiplication(int n, 
float A[n+1][n+1], float B[n+1][n+1], float C[n+1][n+1]){
	int   i,j,k;

	for(j=1; j<=n; j++){
		for(i=1; i<=n; i++){
			C[i][j]=0.0;
			for(k=1; k<=n; k++){
				C[i][j]=C[i][j]+A[i][k]*B[k][j];
			}
		}
	}
}

/* CvO */
int main(void){
	int   NM=4;
	int   i,j,k,p,q;
	float a[NM][NM],U[NM][NM],atmp[NM][NM],UT[NM][NM];
	float amax,theta,sum1,sum2,lambda,lambda2;

	float EPS=1.0E-6;
	float PAI=4.0*atan(1.0);
	
	/* ASY菇PD*/
	int   n=3;
	a[1][1]=1.0;     a[1][2]=2.0;     a[1][3]=1.0;
	a[2][1]=a[1][2]; a[2][2]=1.0;     a[2][3]=0.0;
	a[3][1]=a[1][3]; a[3][2]=a[2][3]; a[3][3]=1.0;

	/* ASY菇QD*/
	int   kmax=10;
	for(k=1; k<=kmax; k++){

		/* ASY菇QDP*/
		amax=0.0;
		for(i=1; i<=n-1; i++){
			for(j=i+1; j<=n; j++){
				if(fabsf(a[i][j])>fabsf(amax)){
					amax=a[i][j];
					p=i;
					q=j;
				}
			}
		}

		/* ASY菇QDQ*/
		if(a[p][p]!=a[q][q]){
			theta=0.5*atan(2.0*a[p][q]/(a[q][q]-a[p][p]));
			if(theta<-PAI/2.0 || theta>PAI/2.0){
				printf("fear of error: theta=%10.6f\n", theta);
			}
		}else{
			theta=copysignf(PAI/4.0,a[p][q]);
          /* copysignf(x,y)́Cx̐ΒlEy̕l */
		}

		/* ASY菇QDR*/
		for(j=1; j<=n; j++){
			for(i=1; i<=n; i++){
				if(i==j){ /* Ίpvf̏ꍇ */
					if(i==p || i==q){ /* U(p,p)U(q,q)cos*/
						U[i][j]=cos(theta);
					}else{ /* ȊȎΊpvf1.0 */
						U[i][j]=1.0;
					}
				}else{ /* ΊpvfłȂꍇ */
					if(i==p && j==q){ /* U(p,q)sin*/
						U[i][j]=sin(theta);
					}else if(i==q && j==p){ /* U(q,p)-sin*/
						U[i][j]=-sin(theta);
					}else{  /* ȊO0.0 */
						U[i][j]=0.0;
					}
				}
			}
		}

		/*iQlj{]so */
		printf("k= %3d \n", k);
		printf("Basic rotation matrix \n");
		for(i=1; i<=n; i++){
			printf("%10.6f %10.6f %10.6f \n", U[i][1],U[i][2],U[i][3]);
		}

		/* ASY菇QDS*/
		transposition(n,U,UT); /* U̓]usUT̍쐬 */
		multiplication(n,a,U,atmp); /* A*Ů|ZAtmpɊi[ */
		multiplication(n,UT,atmp,a); /* UT*Atmp̊|ZVAɊi[ */

		/*iQljvZAo */
		printf("A \n");
		for(i=1; i<=n; i++){
			printf("%10.6f %10.6f %10.6f \n", a[i][1],a[i][2],a[i][3]);
		}

		/* ASY菇RD*/
		if(fabsf(amax)<EPS){ /* Ίpvf̐Βlő̂́iamaxj*/
			printf("Converged! \n \n");
			break;
		}
	}

	/* ʂ̏o */
	for(i=1; i<=n; i++){
		printf("Lambda(%3d)=%10.6f\n", i, a[i][i]);
	}	
	return 0;
}
