/* *******************************************************************
   15.2@gU̍@
******************************************************************* */
#include<stdio.h>
#include<math.h>

/* O[oϐ */
int NM=11;

/* g[}X@vZ邽߂̊֐ */
/* IL`IU܂ŌvZ, ʂzyɊi[ */
float THOMAS(int IL, int IU, float a1[], float b1[],
			float c1[], float d1[], float y[]){
	float g[NM], s[NM];
	int j;

	g[IL]=b1[IL];
	s[IL]=d1[IL];
	for(j=IL+1; j<=IU; j++){
		g[j]=b1[j]-a1[j]*c1[j-1]/g[j-1];
		s[j]=d1[j]-a1[j]* s[j-1]/g[j-1];
	}
	y[IU]=s[IU]/g[IU];
	for(j=IU-1; j>=IL; j--){
		y[j]=(s[j]-c1[j]*y[j+1])/g[j];
	}
}

/* ʂo͂邽߂̊֐ */
void out(float dt, int n, int JJ, float u[]){
	int j;

	printf("%6.3f |", dt*n);
	for(j=0; j<=JJ; j++){
		printf("%6.3f", u[j]);
	}
	printf("\n"); /* s */
}

/* CvO */
int main(void){
	int   N=10;
	int   N1=N-1;
	int   M=100;
	float dt=0.002;
	float dx=1.0/N;
	float r=dt/pow(dx,2);
	float x[NM],f[NM],u[NM],uu[NM];
	float a[NM],b[NM],c[NM],d[NM];
	int   j,k;
	
	/* U_̒` */
	for(j=0; j<=N; j++){
		x[j]=j*dx;
	}

	/* ֐f(x)̒`izƂĕێj*/
	for(j=0; j<=N; j++){
		if(x[j]<=0.5){
			f[j]=2.0*x[j];
		}else{
			f[j]=2.0*(1.0-x[j]);
		}
	}
	
	/*  */
	for(j=0; j<=N; j++){
		u[j]=f[j];
		uu[j]=f[j];
	}
	out(dt,0,N,u); /* ̏o */

	/* 3̌W`ia,b,c͒萔Bd͎ԂƂɍXVj*/
	for(j=1; j<=N1; j++){
		a[j]=-r;
		b[j]=1.0+2.0*r;
		c[j]=-r;
	}
	
	/* Ԃɑ΂vZ */
	for(k=1; k<=M; k++){
		/* 3̌WXV */
		for(j=1; j<=N1; j++){
			d[j]=u[j];
		}
		d[ 1]=d[ 1]-a[ 1]*u[0];
		d[N1]=d[N1]-c[N1]*u[N];

		/* g[}X@ */
		THOMAS(1,N1,a,b,c,d,uu); /* ʂzuuɊi[ */

		/* ʂ̏o */
		out(dt,k,N,uu);
		
		/* uuuɃRs[i̎Ԃ̏j*/
		for(j=1; j<=N1; j++){
			u[j]=uu[j];
		}
	}	
	return 0;
}
